package FDD;

import java.awt.*;
import java.awt.event.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.border.LineBorder;


@SuppressWarnings("serial")
public class FactorioDescriptionDesigner extends JFrame {
	private JTree descriptionTree = new JTree();
	private JTextPane codeEditorText;
	final JComboBox entitySelector;
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public FactorioDescriptionDesigner() throws HeadlessException {
		super("Title");
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 1.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		getContentPane().setLayout(gridBagLayout);
		GridBagConstraints gbc_lblEditorPane_1 = new GridBagConstraints();
		
		JPanel panel_1 = new JPanel();
		panel_1.setAlignmentX(Component.LEFT_ALIGNMENT);
		GridBagConstraints gbc_panel_1 = new GridBagConstraints();
		gbc_panel_1.gridwidth = 8;
		gbc_panel_1.gridheight = 14;
		gbc_panel_1.insets = new Insets(0, 0, 0, 5);
		gbc_panel_1.gridy = 0;
		gbc_panel_1.fill = GridBagConstraints.BOTH;
		gbc_panel_1.gridx = 1;
		getContentPane().add(panel_1, gbc_panel_1);
		GridBagLayout gbl_panel_1 = new GridBagLayout();
		gbl_panel_1.columnWidths = new int[]{95, 0};
		gbl_panel_1.rowHeights = new int[]{0, 0, 0, 14, 0};
		gbl_panel_1.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panel_1.rowWeights = new double[]{0.0, 0.0, 0.0, 1.0, 0.0};
		panel_1.setLayout(gbl_panel_1);
		
		JLabel lblDescriptionSelector = new JLabel("Description Selector");
		lblDescriptionSelector.setAlignmentY(Component.TOP_ALIGNMENT);
		lblDescriptionSelector.setVerticalAlignment(SwingConstants.TOP);
		GridBagConstraints gbc_lblDescriptionSelector = new GridBagConstraints();
		gbc_lblDescriptionSelector.anchor = GridBagConstraints.NORTH;
		gbc_lblDescriptionSelector.insets = new Insets(0, 0, 5, 0);
		gbc_lblDescriptionSelector.gridx = 0;
		gbc_lblDescriptionSelector.gridy = 0;
		panel_1.add(lblDescriptionSelector, gbc_lblDescriptionSelector);
		lblDescriptionSelector.setHorizontalAlignment(SwingConstants.CENTER);
		
		JScrollPane scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.insets = new Insets(0, 0, 5, 0);
		gbc_scrollPane.gridheight = 4;
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 1;
		panel_1.add(scrollPane, gbc_scrollPane);
		
		descriptionTree.setModel(updateTreeModel());
		scrollPane.setViewportView(descriptionTree);
				
		JScrollPane codeEditor = new JScrollPane();
		codeEditor.setViewportBorder(new LineBorder(new Color(0, 0, 0), 2));
		GridBagConstraints gbc_codeEditor = new GridBagConstraints();
		gbc_codeEditor.insets = new Insets(0, 0, 0, 5);
		gbc_codeEditor.fill = GridBagConstraints.BOTH;
		gbc_codeEditor.gridwidth = 11;
		gbc_codeEditor.gridheight = 14;
		gbc_codeEditor.gridx = 14;
		gbc_codeEditor.gridy = 0;
		getContentPane().add(codeEditor, gbc_codeEditor);
		
		codeEditorText = new JTextPane();
		codeEditor.setViewportView(codeEditorText);
		
		JLabel lblCodeEditor = new JLabel("Code Editor");
		lblCodeEditor.setHorizontalAlignment(SwingConstants.CENTER);
		codeEditor.setColumnHeaderView(lblCodeEditor);
		entitySelector = new JComboBox();
		entitySelector.setModel(loadEntityTypes());
		entitySelector.setVisible(false);
		entitySelector.setPrototypeDisplayValue("transport-belt-to-ground");
		GridBagConstraints gbc_entitySelector = new GridBagConstraints();
		gbc_entitySelector.fill = GridBagConstraints.HORIZONTAL;
		gbc_entitySelector.gridx = 10;
		gbc_entitySelector.gridy = 5;
		getContentPane().add(entitySelector, gbc_entitySelector);
		
		JComboBox descriptionSelector = new JComboBox();
		descriptionSelector.setPrototypeDisplayValue("Technology");
		descriptionSelector.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (arg0.getItem().toString().equalsIgnoreCase("Entity")) {
					entitySelector.setVisible(true);
				} else entitySelector.setVisible(false);
			}
		});
		descriptionSelector.setModel(new DefaultComboBoxModel(new String[] {"Item", "Recipe", "Technology", "Entity"}));
		GridBagConstraints gbc_descriptionSelector = new GridBagConstraints();
		gbc_descriptionSelector.insets = new Insets(0, 0, 5, 5);
		gbc_descriptionSelector.gridx = 10;
		gbc_descriptionSelector.gridy = 3;
		getContentPane().add(descriptionSelector, gbc_descriptionSelector);
		
		JButton btnCreateNew = new JButton("Create New");
		GridBagConstraints gbc_btnCreateNew = new GridBagConstraints();
		gbc_btnCreateNew.insets = new Insets(0, 0, 5, 5);
		gbc_btnCreateNew.gridx = 10;
		gbc_btnCreateNew.gridy = 1;
		getContentPane().add(btnCreateNew, gbc_btnCreateNew);
		
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmOpen = new JMenuItem("Open");
		mntmOpen.setAction(
				new SwingAction() {
					@Override
					public void actionPerformed(ActionEvent e) {
						super.actionPerformed(e); // not sure if I actually need this or not...
						loadDescriptionFile();
					}
				});
		mnFile.add(mntmOpen);
		
		JMenuItem mntmSave = new JMenuItem("Save");
		mntmSave.setAction(
				new SwingAction() {
					@Override
					public void actionPerformed(ActionEvent e) {
						super.actionPerformed(e); // not sure if I actually need this or not...
						saveDescriptionFile();
					}
				});
		mnFile.add(mntmSave);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mnFile.add(mntmExit);
	}
	
	protected void saveDescriptionFile() { // TODO: maybe check create boolean ifSaved==true then save to same file
		JFileChooser fileChooser = new JFileChooser();
		if (fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
		  File file = fileChooser.getSelectedFile();
		  try {
			  BufferedWriter bw = new BufferedWriter(new FileWriter(file.getAbsoluteFile()));
			  bw.write(codeEditorText.getText());
			  bw.close();
		  } catch (IOException e1) {
			  e1.printStackTrace();
		  } // end try
		} // close if
	}

	protected void loadDescriptionFile() {
		JFileChooser fileChooser = new JFileChooser();
		if (fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
		  File file = fileChooser.getSelectedFile();
		  try {
			  BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			  String nextLine;
			  String code = "";
			  while ((nextLine = br.readLine()) != null) {
				  code = code + System.lineSeparator() + nextLine;
			  }
			  br.close();
		  } catch (IOException e1) {
			  e1.printStackTrace();
		  } // end try
		} // close if
		// TODO: parse loaded definitions, add to JTree and show in codeEditor  
	}

	private TreeModel updateTreeModel() { //TODO: figure out how to use JTree
		// if loading a definition file, add current definitions to JTree in nodes of Items/Entities/Technology/Recipes
		TreeModel Tree = null;
		return Tree;
	}
	
	private TreeModel updateTreeModel(ArrayList<String> newContent) { //TODO: figure out how to use JTree
		// Should be called when new definitions are added to the file, updating the tree
		TreeModel Tree = null;
		return Tree;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public ComboBoxModel loadEntityTypes() {
		ArrayList<String> entityTypes = new ArrayList<String>();
		try {
			File file = new File("EntityTypes.txt");
			String nextLine;
			BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			while ((nextLine = br.readLine()) != null) {
				entityTypes.add(nextLine);
			}
			br.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		} // end try
		return new DefaultComboBoxModel(entityTypes.toArray(new String[0]));
	}
	
	public ArrayList<String> loadEntityCode() { // TODO: Setup Entity Code, and load it!!!
		ArrayList<String> entityTypes = new ArrayList<String>();
		try {
			File file = new File("EntityCode.txt");
			String nextLine;
			BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			while ((nextLine = br.readLine()) != null) {
				entityTypes.add(nextLine);
			}
			br.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		} // end try
		return entityTypes;
	}
	
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public ComboBoxModel loadItemTypes() {
		ArrayList<String> ItemTypes = new ArrayList<String>();
		try {
			File file = new File("ItemTypes.txt");
			String nextLine;
			BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			while ((nextLine = br.readLine()) != null) {
				ItemTypes.add(nextLine);
			}
			br.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		} // end try
		return new DefaultComboBoxModel(ItemTypes.toArray(new String[0]));
	}
	
	public ArrayList<String> loadItemCode() {
		ArrayList<String> ItemCode = new ArrayList<String>();
		try {
			File file = new File("ItemCode.txt");
			String nextLine;
			BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			while ((nextLine = br.readLine()) != null) {
				ItemCode.add(nextLine);
			}
			br.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		} // end try
		return ItemCode;
	}
	
	public ArrayList<String> loadTechnologyCode() {
		ArrayList<String> TechCode = new ArrayList<String>();
		try {
			File file = new File("TechCode.txt");
			String nextLine;
			BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			while ((nextLine = br.readLine()) != null) {
				TechCode.add(nextLine);
			}
			br.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		} // end try
		return TechCode;
	}
	
	public ArrayList<String> loadRecipeCode() { // TODO: create recipe code file
		ArrayList<String> RecipeCode = new ArrayList<String>();
		try {
			File file = new File("RecipeCode.txt");
			String nextLine;
			BufferedReader br = new BufferedReader(new FileReader(file.getAbsoluteFile()));
			while ((nextLine = br.readLine()) != null) {
				RecipeCode.add(nextLine);
			}
			br.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		} // end try
		return RecipeCode;
	}

	public static void main(String[] args) {
		FactorioDescriptionDesigner GUI = new FactorioDescriptionDesigner();
		GUI.setDefaultCloseOperation(EXIT_ON_CLOSE);
		GUI.setSize(800, 600);
		GUI.setVisible(true);
	}
	private class SwingAction extends AbstractAction {
		public SwingAction() {
			putValue(NAME, "SwingAction");
			putValue(SHORT_DESCRIPTION, "Some short description");
		}
		public void actionPerformed(ActionEvent e) {
		}
	}
}
